﻿using Dapper;
using Npgsql;
using WebApiSkeleton.DatabaseMapping.Example;

// instruction for Dapper to match column names in snake_case to properties named in camel case (SnakeCase)
DefaultTypeMap.MatchNamesWithUnderscores = true;
const string connectionString = "Host=localhost;Port=5432;Username=postgres;Password=postgres;Database=mapping_test";

using var connection = new NpgsqlConnection(connectionString);

InitializeTable(connection);
var userMapping = new UserDatabaseMap();

// alternatively to MatchNamesWithUnderscores you can manually define property name as an alias
var sql = $"""
           SELECT {userMapping[x => x.Id]} "{nameof(User.Id)}",
                  {userMapping[x => x.FirstName]} "{nameof(User.FirstName)}",
                  {userMapping[nameof(User.LastName)]} "LastName",
                  {userMapping[nameof(User.Age)]} "Age"
           FROM {userMapping.SchemaQualifiedTableName}
           WHERE {userMapping[nameof(User.Id)]} = @id
           """;

var user = connection.QueryFirst<User>(sql, new { id = 1 });
Console.WriteLine(user);


return;

void InitializeTable(NpgsqlConnection connection)
{
    connection.Execute(
        """
        CREATE TABLE IF NOT EXISTS public.user
        (
            id integer primary key generated by default as identity,
            first_name varchar(50) not null,
            last_name varchar(50) not null,
            age integer not null
        );
        """);
    connection.Execute("INSERT INTO public.user(first_name, last_name, age) VALUES ('test', 'test', 20)");
}